/**
 * @(#)ScreenLocField.
 * Copyright © 2013 jbundle.org. All rights reserved.
 * GPL3 Open Source Software License.
 */
package org.jbundle.app.program.db;

import java.util.*;

import org.jbundle.base.db.*;
import org.jbundle.thin.base.util.*;
import org.jbundle.thin.base.db.*;
import org.jbundle.base.db.event.*;
import org.jbundle.base.db.filter.*;
import org.jbundle.base.field.*;
import org.jbundle.base.field.convert.*;
import org.jbundle.base.field.event.*;
import org.jbundle.base.model.*;
import org.jbundle.base.util.*;
import org.jbundle.model.*;
import org.jbundle.model.db.*;
import org.jbundle.model.screen.*;

/**
 *  ScreenLocField - Screen location.
 */
public class ScreenLocField extends StringPopupField
{
    /**
     * Default constructor.
     */
    public ScreenLocField()
    {
        super();
    }
    /**
     * Constructor.
     * @param record The parent record.
     * @param strName The field name.
     * @param iDataLength The maximum string length (pass -1 for default).
     * @param strDesc The string description (usually pass null, to use the resource file desc).
     * @param strDefault The default value (if object, this value is the default value, if string, the string is the default).
     */
    public ScreenLocField(Record record, String strName, int iDataLength, String strDesc, Object strDefault)
    {
        this();
        this.init(record, strName, iDataLength, strDesc, strDefault);
    }
    /**
     * Initialize class fields.
     */
    public void init(Record record, String strName, int iDataLength, String strDesc, Object strDefault)
    {
        super.init(record, strName, iDataLength, strDesc, strDefault);
    }
    /**
     * Get the conversion Map.
     */
    public String[][] getPopupMap()
    {
        String string[][] = {
            {"", "Default"}, 
            {"NEXT_LOGICAL", "Next Logical"},
            {"RIGHT_OF_LAST", "Right of Last"},
            {"BELOW_LAST", "Below Last"},
            {"TOP_NEXT", "Top Next"},
            {"AT_ANCHOR", "At Anchor"},
            {"USE_THIS_LOCATION", "Use This Location"},
            {"RIGHT_WITH_DESC", "Right With Desc"},
            {"NEXT_INPUT_LOCATION", "Next Input Location"},
            {"USE_ROW_COL", "Use Row/Col"}
        };
        return string;
    }

}
